﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Windows;
using SlimDX;
using SlimDX.D3DCompiler;
using SlimDX.Direct3D11;
using SlimDX.DXGI;
using FarseerPhysics.Collision;
using FarseerPhysics.Common;
using FarseerPhysics.Controllers;
using FarseerPhysics.Dynamics;

namespace LittleBigTable
{
    using Vec2 = Microsoft.Xna.Framework.Vector2;
    //We use some roles( in the global scope to define the roles and pigs)
    public partial class MainForm : Form
    {

        SceneManager scene;

        System.Drawing.Point formPoint;
       
        public MainForm()
        {
            InitializeComponent();
        }

        private void MainForm_Click(object sender, System.EventArgs e)
        {
           
        }
        private void MainForm_Load(object sender, System.EventArgs e)
        {

            scene = new SceneManager(Handle, ClientSize.Width, ClientSize.Height);

            //firstScene = new GameScene();
            //firstScene.NewGame(scene);
        }

        private void MainForm_FormClosing(object sender, FormClosingEventArgs e)
        {

        }
        private void ResizeD(int width, int height)
        {
           
        }
        private void MainForm_ClientSizeChanged(object sender, System.EventArgs e)
        {
            //if (ClientSize.Width > 0 && ClientSize.Width > 0)
            //{
            //    scene.GetTextSets().ResizeTexture(ClientSize.Width, ClientSize.Height, scene.GetDevice().GetDevice(), scene.GetDevice().GetAdapter());
            //    this.scene.GetCamera().SetWidthHeight(ClientSize.Width, ClientSize.Height);
            //    this.scene.GetDevice().Resize(ClientSize.Width, ClientSize.Height);
            //}
        }
        public void SetMouse()
        {
            System.Drawing.Point d = Control.MousePosition;
            if (!this.IsDisposed)
            {
                formPoint = PointToClient(d);
            }
            int xForm = formPoint.X;
            int yForm = formPoint.Y;
            scene.SetMousePosition(xForm, yForm);
        }
        internal void Render()
        {
            scene.Render(0.01f);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            scene.Restart();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            scene.ApplyImpulse();
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            scene.BallConficient = (float)trackBar1.Value / 100.0f;
        }

        private void trackBar2_Scroll(object sender, EventArgs e)
        {
            scene.GroundCofficient= (float)trackBar2.Value / 100.0f;
        }

        private void trackBar3_Scroll(object sender, EventArgs e)
        {
            scene.BallFriction = (float)trackBar3.Value / 100.0f;
        }

        private void trackBar4_Scroll(object sender, EventArgs e)
        {
            scene.GroundFriction = (float)trackBar4.Value / 100.0f;
        }

    }
}
